.nolist
#include "tse.inc"
.list

.org    userMem-3
.db     $BB,$6D
 ret

 .db "TSE",1           ; Header
title:                 ; Title
 .db " Utopia v1.8 - Michael Vincent", 0
 .dw 60                ; Stack Required
MenuTitle        .equ title + 1
;
; Copyright 2000, Michael Vincent & Robin Kay. All rights reserved.
;
; You may take code from or base your program on this code as long as
; at least 50% of the program is your work.
;
;
start:
 ld a,(calcspeed)
 di
 out (4),a
 ei
 ; Initalize Index and Selected
 ld hl, 0
 ld (MenuIndex), hl

rebuildMenu:
 ; Clear screen and display title and battery info
 bcall(_clrScrnFull)  
 bcall(_cleargbuf)
 bit 5,(iy+18h)
 jr nz, battsareok
 ld ix,BadBattery
 jr showsprite
battsareok:
 ld ix,GoodBattery
showsprite:
 ld b,6
 ld a,88
 ld l,58
 call _tseSprite
 call _tseFastCopy
 ld hl,3900h
 ld (pencol), hl
 ld hl,FreeMem
 bcall(_vputs)
 bcall(_memchk)
 bcall(_setxxxxop2)
 bcall(_op2toop1)
 bcall(_dispop1a)
 ld hl, 0
 ld (pencol), hl
 ld hl, MenuTitle
 bcall(_vputs)
 xor a
 ld (pencol), a
 ld a, (penrow)
 add a, 7
 ld (penrow), a
 ld bc, 0000h+(64-7)
 ld de, 5F00h+(64-7)
 ld h, 1
 bcall(_iline)
 ld c, 07h
 ld e, c
 bcall(_iline)

 ; Init Display menu
 xor a
 ld (MenuLimit), a
 ld a, (MenuIndex)
 ld b, a
loopDrawMenu:

 ; Get program title
 inc b
 push bc
 call getprog
 cp 0
 jr z, notFinished
 pop bc
 jr finished
notFinished:
 call _tseChkprog
 cp 0
 jr z, notFlash

 ; Mark if flash
Flash:
 push hl
 ld hl, arc
 bcall(_vputs)
 pop hl
notFlash:

 ; Display entry
 bcall(_vputs)
 xor a
 ld (pencol), a
 ld a, (penrow)
 add a, 6
 ld (penrow), a

 ; Increase limit
 ld hl, MenuLimit
 inc (hl)

 ; Check if menu full
 pop bc
 ld a, (hl)
 cp 8
 jr nz, loopDrawMenu
finished:

 ; Handle selected beyond end of menu
 ld a, (MenuSelect)
 ld b, a
 ld a, (MenuLimit)
 dec a
 cp b
 jr nc, skip1
 ld (MenuSelect), a
skip1:

 ; Handle empty menu
 ld a, (MenuLimit)
 cp 0
 jr nz, skip2
 ld a, (MenuIndex)
 cp 0
 jp z, _tseExitShell
 xor a
 ld (MenuIndex), a
 jp rebuildMenu
skip2:

 ; Highlight Entry
 ld a, (MenuSelect)
 call highlightMenuItem

 ; Implement delay
loopMenuKeypad:

 ; Poll keypad
 ei
 halt ; Save power
 bcall(_getCSC)
 ; Handle the quit key
 cp skMode
 call z, _tseExitShell

 ; Handle keys that refresh the display
 ld hl, rebuildMenu
 push hl
 cp skLeft
 jr z, moveLeft
 cp skRight
 jr z, moveRight
 cp skAlpha
 jp z, task_end
 cp sk2nd
 jp z, task_exec
 cp skEnter
 jp z, task_exec
 cp skGraphvar
 jp z, arc_unarc
 cp skApps
 jp z,lockdown
 cp skPrgm
 jp z,changepassword
 pop hl

 ; Handle keys that't don't need to refresh display
 ld hl, loopMenuKeypad
 push hl
 cp skUp
 jr z, moveUp
 cp skDown
 jr z, moveDown
 cp skClear
 jp z, PowerOff
 cp skYEqu
 jp z,maxspeed
 cp skWindow
 jp z,morespeed
 cp skZoom
 jp z,smorespeed
 cp skTrace
 jp z,normalspeed

 ; Loop back up
 ret

 ; Move Left
moveLeft:
 ld a, (MenuIndex)
 add a, -8
 ld (MenuIndex), a 
 ret

 ; Move Right
moveRight:
 ld a, (MenuIndex)
 add a, 8
 ld (MenuIndex), a 
 ret

moveUp:

 ; Check if top of list
 ld a, (MenuSelect)
 cp 0
 ret z

 ; Move Up
 call highlightMenuItem
 dec a
 ld (MenuSelect), a
 call highlightMenuItem
 ret

moveDown:

 ; Check if bottom of list
 ld a, (MenuLimit)
 dec a
 ld c, a
 ld a, (MenuSelect)
 cp c
 ret z

 ; Move down
 call highlightMenuItem
 inc a
 ld (MenuSelect), a
 call highlightMenuItem
 ret

 ; Power Off
PowerOff:
 ld a, 1
 out (3),a ; Disable timer?
 ei
 halt ; Wait for ON interrupt
 res onInterrupt,(iy+onflags)
 ret                               
normalspeed:
	di	
	ld a,%00000110
	out (4),a
	ld (calcspeed),a
	ei
	ret	
maxspeed:
	di
	ld a,%00000000	;set speed to fastest setting
	out (4),a
	ld (calcspeed),a
	ei
	ret	
morespeed:
	di
	ld a,%00000010
	out (4),a
	ld (calcspeed),a
	ei
	ret	
smorespeed:
	di	
	ld a,%00000100
	out (4),a
	ld (calcspeed),a
	ei
	ret	
changepassword:
 ld a,(passw1)
 cp 0
 call nz,lockdown
 call MakePassword
 ret
lockdown:
 ld a,(passw1)
 cp 0
 call z,MakePassword
 bcall(_clrLCDFull)
 ld hl,0000h
 ld (currow),hl
 ld hl,passprompt
 bcall(_puts)
 ld hl,0006h
 ld (currow),hl
 call PowerOff
getloop1:
 ei
 halt
 bcall(_getcsc)
 cp 0
 jr z,getloop1
 ld hl,(passw1)
 cp l
 jp nz,lockdown
 ld hl,passchar
 bcall(_puts)
getloop2:
 ei
 halt
 bcall(_getcsc)
 cp 0
 jr z,getloop2
 ld hl,(passw2)
 cp l
 jp nz,lockdown
 ld hl,passchar
 bcall(_puts)
getloop3:
 ei
 halt
 bcall(_getcsc)
 cp 0
 jr z,getloop3
 ld hl,(passw3)
 cp l
 jp nz,lockdown
 ld hl,passchar
 bcall(_puts)
getloop4:
 ei
 halt
 bcall(_getcsc)
 cp 0
 jr z,getloop4
 ld hl,(passw4)
 cp l
 jr nz,lockdown
 ld hl,passchar
 bcall(_puts)
 ret

MakePassword:
 bcall(_clrLCDFull)
 ld hl,0000h
 ld (pencol),hl
 ld hl,newpass
 bcall(_vputs)
 ld hl,0700h
 ld (pencol),hl
 ld hl,newpass2
 bcall(_vputs)
 ld hl,1500h
 ld (pencol),hl
loop1:
 bcall(_getcsc)
 cp 0
 jr z,loop1
 ld (passw1),a
 ld hl,passchar
 bcall(_vputs)
loop2:
 bcall(_getcsc)
 cp 0
 jr z,loop2
 ld (passw2),a
 ld hl,passchar
 bcall(_vputs)
loop3:
 bcall(_getcsc)
 cp 0
 jr z,loop3
 ld (passw3),a
 ld hl,passchar
 bcall(_vputs)
loop4:
 bcall(_getcsc)
 cp 0
 jr z,loop4
 ld (passw4),a
 ld hl,passchar
 bcall(_vputs)
 bcall(_clrLCDFull)
 ld hl,0000h
 ld (pencol),hl
 ld hl,passset
 bcall(_vputs)
 call PauseKey
 ret
PauseKey:
looppause:
 bcall(_getcsc)
 cp 0
 jr z,looppause
 ret

; Execute task
task_exec:
 call getsprog
 call _tseChkProg
 cp 0
 jr z,dotask
 call arc_unarc
 jp task_exec
dotask:
 call _tseStartTask
 cp 4
 jr z, ok2
 cp 0
 ret nz
ok2:
 call _tseSwitchTask
 ret

 ; End task
task_end:
 call getsprog
 call _tseChkProg
 cp 0
 ret nz
 call _tseEndTask
 ret

 ; Archive/Unarchive program
arc_unarc:
 call getsprog
 call _tseChkProg

 ; Borrow system stack
 ld (tempword), sp
 ld hl, (sysstack)
 ld sp, hl

 ; Do arc/unarc and handle errors
 AppOnErr(arc_err)
 bcall(_Arc_UnArc)
 AppOffErr()
arc_err:

 ; Restore stack
 ld hl, (tempword)
 ld sp, hl
 ret

;--Functions--

; Highlight Menu Entry
; a should contain the menu item to be selected
;
highlightMenuItem:
 push af
 ld b, a
 ld a, 7
highlightLoop:
 add a, 6
 djnz highlightLoop  
 ld h, a
 add a, 6
 ld d, a
 ld e, 5Fh
 ld l, 0
 bcall(_invertRect)
 pop af
 ret

; Get number of selected program and runs into getprog
;
getsprog:
 ld a, (MenuSelect)
 ld b, a
 ld a, (MenuIndex)
 add a, b
 ld b, a
 inc b

; Convert TSE prog number into _tseFindVar number
; 
getprog:
 ld c, 0
getprogloop:
 inc c
 ld a, c
 push bc
 call _tseFindVar
 pop bc
 ld a, 0ffh
 ret nz
 push bc
 call _tseChkProg
 pop bc
 cp 2
 jr z, okFlash
 cp 0
 jr nz, getprogloop
okFlash:
 djnz getprogloop
 xor a
 ret
GoodBattery:
 .db %00001100
 .db %00011110
 .db %00011110
 .db %00011110
 .db %00011110
 .db %00011110
BadBattery:
 .db %00001100
 .db %00011110
 .db %00010010
 .db %00010010
 .db %00010010
 .db %00011110
;--Data
arc:
.db "(A)",0
FreeMem:
	.db "Free RAM:  ",0
calcspeed:
	.db %00000110
passw1:
	.db 0
passw2:
	.db 0
passw3:
	.db 0
passw4:
	.db 0
newpass:
	.db "No password found. Please",0
newpass2:
	.db "Type a 4-key password.",0
passchar:
	.db "*",0
passset:
	.db "Password set. Press enter.",0
passprompt:
	.db "Please enter the"
	.db "password to     "
	.db "access this     "
	.db "calculator.",0

extdata:

MenuIndex    .equ extdata
MenuSelect   .equ MenuIndex+1
MenuLimit    .equ MenuSelect+1
tempword     .equ MenuLimit+1
.end

